"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = exports.gdf = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _require = require("./require");

var _requireFromString = _interopRequireDefault(require("require-from-string"));

// Generated by CoffeeScript 2.3.2
// import dd from 'ddeyes'
var _getParentFilename;

var gdf = function gdf(obj) {
  return obj.default;
};

exports.gdf = gdf;

_getParentFilename = function getParentFilename() {
  var parent = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : module.parent;

  if (parent.parent != null) {
    return _getParentFilename(parent.parent);
  } else {
    return parent.filename;
  }
};

var _default = function _default(plugins) {
  return {
    /* plugins like
      * coffee
      export default (ops) =>
         name: '$pluginName'
        exts: [
          '.coffee'
        ]
        compiler: (code, id) =>
      * reason
     [
      coffee()
      reason()
    ]
      */
    require: function require(requirePath) {
      var parentPath = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : _getParentFilename();
      var code, e, reducer, requireFile;
      requireFile = _path.default.join(_path.default.dirname(parentPath), requirePath);

      reducer = function reducer(r, _ref) {
        var name = _ref.name,
            exts = _ref.exts,
            compiler = _ref.compiler;
        var baseCode, id;

        if (r.code !== '') {
          return;
        }

        id = (0, _require.getFilePath)(requireFile, exts);
        baseCode = (0, _require.getFileCode)(id);
        r.code = compiler(baseCode, id);
        return r;
      };

      var _plugins$reduce = plugins.reduce(reducer, {
        code: ''
      });

      code = _plugins$reduce.code;

      try {
        return (0, _requireFromString.default)(code);
      } catch (error) {
        e = error;
        return console.error(e);
      }
    },
    requireAsync: function () {
      var _requireAsync = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee2(requirePath) {
        var parentPath,
            code,
            e,
            reducer,
            requireFile,
            _ref4,
            _args2 = arguments;

        return _regenerator.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                parentPath = _args2.length > 1 && _args2[1] !== undefined ? _args2[1] : _getParentFilename();
                requireFile = _path.default.join(_path.default.dirname(parentPath), requirePath);

                reducer =
                /*#__PURE__*/
                function () {
                  var _ref3 = (0, _asyncToGenerator2.default)(
                  /*#__PURE__*/
                  _regenerator.default.mark(function _callee(r, _ref2) {
                    var name, exts, compiler, baseCode, id;
                    return _regenerator.default.wrap(function _callee$(_context) {
                      while (1) {
                        switch (_context.prev = _context.next) {
                          case 0:
                            name = _ref2.name, exts = _ref2.exts, compiler = _ref2.compiler;

                            if (!(r.code !== '')) {
                              _context.next = 3;
                              break;
                            }

                            return _context.abrupt("return");

                          case 3:
                            id = (0, _require.getFilePath)(requireFile, exts);
                            baseCode = (0, _require.getFileCode)(id);
                            _context.next = 7;
                            return compiler(baseCode, id);

                          case 7:
                            r.code = _context.sent;
                            return _context.abrupt("return", r);

                          case 9:
                          case "end":
                            return _context.stop();
                        }
                      }
                    }, _callee, this);
                  }));

                  return function reducer(_x2, _x3) {
                    return _ref3.apply(this, arguments);
                  };
                }();

                _context2.next = 5;
                return plugins.reduce(reducer, {
                  code: ''
                });

              case 5:
                _ref4 = _context2.sent;
                code = _ref4.code;
                _context2.prev = 7;
                return _context2.abrupt("return", (0, _requireFromString.default)(code));

              case 11:
                _context2.prev = 11;
                _context2.t0 = _context2["catch"](7);
                e = _context2.t0;
                return _context2.abrupt("return", console.error(e));

              case 15:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2, this, [[7, 11]]);
      }));

      return function requireAsync(_x) {
        return _requireAsync.apply(this, arguments);
      };
    }(),
    register: function register() {
      var Module;

      if (!require.extensions) {
        return;
      }

      plugins.map(function (_ref5) {
        var name = _ref5.name,
            exts = _ref5.exts,
            compiler = _ref5.compiler;
        return exts.map(function (ext) {
          return require.extensions[ext] = function (module, filename) {
            var answer;
            answer = compiler((0, _require.getFileCode)((0, _require.getFilePath)(filename, exts)), filename);
            return module._compile(answer, filename);
          };
        });
      });
      Module = require('module'); // findExtension = (filename) =>
      //   extensions = path
      //   .basename filename
      //   .split '.'
      //   extensions.shift() if extensions[0] is ''
      //   while extensions.shift()
      //     curExtension = '.' + extensions.join '.'
      //     return curExtension if Module._extensions[curExtension]
      //   '.js'

      Module.prototype.load = function (filePath) {
        var extension, id;

        var _plugins$reduce2 = plugins.reduce(function (r, _ref6) {
          var name = _ref6.name,
              exts = _ref6.exts,
              compiler = _ref6.compiler;

          if (r.id !== '') {
            return;
          }

          r.id = (0, _require.getFilePath)(filePath, exts);
          return r;
        }, {
          id: ''
        });

        id = _plugins$reduce2.id;

        // dd filePath unless id?
        if (id == null) {
          return;
        }

        this.filename = id;
        this.paths = Module._nodeModulePaths(_path.default.dirname(id));
        extension = _path.default.extname(id);

        Module._extensions[extension](this, id);

        return this.loaded = true;
      };
    }
  };
};

exports.default = _default;