// Generated by CoffeeScript 2.3.2
// import dd from 'ddeyes'
var getParentFilename;

import path from 'path';

import {
  getFilePath,
  getFileCode
} from './require';

import requireFromString from 'require-from-string';

export var gdf = (obj) => {
  return obj.default;
};

getParentFilename = (parent = module.parent) => {
  if (parent.parent != null) {
    return getParentFilename(parent.parent);
  } else {
    return parent.filename;
  }
};

export default (plugins) => {
  return {
    /* plugins like

     * coffee
      export default (ops) =>

        name: '$pluginName'
        exts: [
          '.coffee'
        ]
        compiler: (code, id) =>

     * reason

    [
      coffee()
      reason()
    ]

     */
    require: (requirePath, parentPath = getParentFilename()) => {
      var code, e, reducer, requireFile;
      requireFile = path.join(path.dirname(parentPath), requirePath);
      reducer = function(r, {name, exts, compiler}) {
        var baseCode, id;
        if (r.code !== '') {
          return;
        }
        id = getFilePath(requireFile, exts);
        baseCode = getFileCode(id);
        r.code = compiler(baseCode, id);
        return r;
      };
      ({code} = plugins.reduce(reducer, {
        code: ''
      }));
      try {
        return requireFromString(code);
      } catch (error) {
        e = error;
        return console.error(e);
      }
    },
    requireAsync: async(requirePath, parentPath = getParentFilename()) => {
      var code, e, reducer, requireFile;
      requireFile = path.join(path.dirname(parentPath), requirePath);
      reducer = async(r, {name, exts, compiler}) => {
        var baseCode, id;
        if (r.code !== '') {
          return;
        }
        id = getFilePath(requireFile, exts);
        baseCode = getFileCode(id);
        r.code = (await compiler(baseCode, id));
        return r;
      };
      ({code} = (await plugins.reduce(reducer, {
        code: ''
      })));
      try {
        return requireFromString(code);
      } catch (error) {
        e = error;
        return console.error(e);
      }
    },
    register: () => {
      var Module;
      if (!require.extensions) {
        return;
      }
      plugins.map(({name, exts, compiler}) => {
        return exts.map((ext) => {
          return require.extensions[ext] = (module, filename) => {
            var answer;
            answer = compiler(getFileCode(getFilePath(filename, exts)), filename);
            return module._compile(answer, filename);
          };
        });
      });
      Module = require('module');
      // findExtension = (filename) =>
      //   extensions = path
      //   .basename filename
      //   .split '.'
      //   extensions.shift() if extensions[0] is ''
      //   while extensions.shift()
      //     curExtension = '.' + extensions.join '.'
      //     return curExtension if Module._extensions[curExtension]
      //   '.js'
      Module.prototype.load = function(filePath) {
        var extension, id;
        ({id} = plugins.reduce((r, {name, exts, compiler}) => {
          if (r.id !== '') {
            return;
          }
          r.id = getFilePath(filePath, exts);
          return r;
        }, {
          id: ''
        }));
        // dd filePath unless id?
        if (id == null) {
          return;
        }
        this.filename = id;
        this.paths = Module._nodeModulePaths(path.dirname(id));
        extension = path.extname(id);
        Module._extensions[extension](this, id);
        return this.loaded = true;
      };
    }
  };
};
